/*use BC ++ compiler */

#include <alloc.h>
#include <bios.h>
#include <conio.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <graphics.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "mouse.h"
#include "mask.h"
#include "chinese.h"


#define MAXY 479
#define MAXX 639

#define NOT_SUCH_FILES	  -10
#define OUT_OF_MEMORY	  -1
#define ERROR		  0
#define FILE_OPEN_ERROR   -11
#define FONT_OPEN_ERROR   -12
#define FILE_READ_ERROR   -13
#define ERROR_GRAPHICS	  -20
#define DRIVE_NOT_READY   2
#define CLIST_HELP	  1
#define CLIST_FILES	  2

#define ALT_F		 256+33
#define ALT_L		 256+38
#define ALT_P		 256+25
#define ALT_Q		 256+16
#define ALT_R		 256+19
#define ALT_S		 256+31
#define BACKSPACE	 8
#define ENTER		 13
#define SPACE		 32
#define ESC		 27
#define ADD		 43
#define EQUATE		 61
#define MINUS		 45
#define CTRL_DOWN	 256+145
#define CTRL_UP 	 256+141
#define CTRL_HOME	 256+119
#define CTRL_END	 256+117
#define CTRL_PAGE_UP	 256+132
#define CTRL_PAGE_DOWN	 256+118
#define UP1		 256+72
#define UP2		 56
#define DOWN1		 256+80
#define DOWN2		 50
#define LEFT1		 256+75
#define LEFT2		 52
#define RIGHT1		 256+77
#define RIGHT2		 54
#define PAGE_UP1	 256+73
#define PAGE_UP2	 57
#define PAGE_DOWN1	 256+81
#define PAGE_DOWN2	 51
#define HOME1		 256+71
#define HOME2		 55
#define END1		 256+79
#define END2		 49
#define F1		 256+59
#define F2		 256+60
#define F3		 256+61
#define F4		 256+62
#define F5		 256+63
#define F11		 256+133
#define MOUSE_RIGHT	 2*256+10
#define MOUSE_RIGHT1	 2*256+11
#define MOUSE_LEFT	 2*256+20
#define MOUSE_LEFT1	 2*256+21
#define MOUSE_UP	 2*256+30
#define MOUSE_UP1	 2*256+31
#define MOUSE_DOWN	 2*256+40
#define MOUSE_DOWN1	 2*256+41
#define MOUSE_PAGE_UP	 2*256+50
#define MOUSE_PAGE_UP1	 2*256+51
#define MOUSE_PAGE_DOWN  2*256+60
#define MOUSE_PAGE_DOWN1 2*256+61
#define MOUSE_START	 2*256+70
#define MOUSE_FILE_END	 2*256+80
#define MOUSE_ESC	 2*256+90
#define MOUSE_FILE_MENU  2*256+100
#define MOUSE_QUIT	 2*256+110
#define MOUSE_NOTE	 2*256+120
#define MOUSE_SEARCH_LINE 2*256+130
#define MOUSE_PERCENT	 2*256+150
#define MOUSE_LOAD_FILES 2*256+180
#define MOUSE_AUTHOR	 2*256+300
#define MOUSE_BREAK	 2*256+500+2
#define READ_BYTES 256

#define TRUE 1
#define FALSE 0

/* mouse define */
#define EV_MOUSE_MOVE		1
#define EV_LEFT_PRESS		2
#define EV_LEFT_RELEASE 	4
#define EV_RIGHT_PRESS		8
#define EV_RIGHT_RELEASE       16
#define EV_MIDDLE_PRESS        32
#define EV_MIDDLE_RELEASE      64
#define EV_MOUSE_ALL	       127
#define EVENT_AND		0
#define EVENT_OR		1

#define PAGE_LINES		25

#define CHIN_FONT_PATH	"#CFMP#\nc:\\et3\\ascfont.15\nc:\\et3\\stdfont.15\nc:\\et3\\spcfont.15\nc:\\et3\\spcfsupp.15\n"
#define MEMORY_ALLOC		8820+10240    /* mem alloc + read_buffer */
typedef void (far *Handler)(void);

struct files_name
  { struct files_name *ahead;
    char file_name[15];
    struct files_name *next;
  };
typedef struct files_name *FN;

int  alloc_mem(void);
void author(void);
// void bar(int,int,int,int,unsigned int);
void change_percent(void);
int  clist(int,int,unsigned char *,int legnth,int fcolor,int bcolor);
int  clist_files(char *,int);
int  clist_file(char *);
int  ctrl_handler(void);
void draw_down(int,int);
void draw_cur(int sit);
void draw_end(int,int);
void draw_esc(int,int);
void draw_file(unsigned char *);
void draw_file_menu(int);
void draw_file_sit(void);
void draw_left(int,int);
void draw_lines(int sit);
void draw_mark(void);
void draw_more(int,int);
void draw_mouse(int sit,int fun,int draw_color,int fill_color);
void draw_page_down(int,int);
void draw_pages(int sit);
void draw_pass_bytes(int sit);
void draw_percent(long,int sit);
void draw_page_up(int,int);
void draw_percent_bar(void);
void draw_percent_point(long,long,int,int);
void draw_quit(int);
void draw_right(int,int);
void draw_start(int,int);
void draw_total_bytes(int sit);
void draw_up(int,int);
void draw_title(void);
void draw_window(int left,int top,int right,int down,int bcolor);
void files_menu_message(char *,char *,char *);
void file_message(void);
int  find_files(struct ffblk *,unsigned char *,unsigned char *,int,int);
void find_file_sit(void);
void free_file_list(FN,FN);
void fun_key(int hitkey);
int  ggets(int,int,unsigned char *,int,int,int);
int  harderror_handler(int errorcode,int deverror,int bpval,int sival);
void help(void);
void hit_anykey(void);
int  init_sys(void);
void line_cur(unsigned char *,int);
int  l_to_s(unsigned char *,long);
int  load_files(unsigned char *);
int  load_font_buffer(void);
int  my_read(int,int);
int  myread(int,char *,int);
int  mygetch(int);
int  open_font_files(void);
int  page_down(int ny);
int  parameter(char *);
// void putpixel(int,int,int);
void puts_message(unsigned char *message,int,int,int);
void quit(void);
int  read_lines(int);
void screen_down(int);
void screen_up(int);
long search_line(long lines);
void test_display(void);
int  test_path(char *,char *,char *);
int  to_file_end(void);
void to_search_line(void);
int  true_strlen(unsigned char *);
/*  Mouse prototype */
int  Mouse_Init(void) ;
void Mouse_End(void) ;
int  mouse_double_click(int,int,int);
int  detect_mouse_key(void);
int  run_mouse(void);
void wait_mouse_release(unsigned);


int  ftr,buffer_ch[2],buffer_size[2];
long buffer_point[2];
char *vtr;
char chmode,active=0,graph_mode=0;
char *error_message,error_flag=0,error=0;
unsigned char *clist_lines[27],*clist_buffer,*buffer,*temp,*rb;
unsigned char *read_buffer,*clist_line,*read_message,*file_name;
char *font_ptr[5];
unsigned b_plan[4];
int  font_handle[4];
int  nowx,nowy;
long font_load_num=0;
long lines,total_bytes,pass_bytes,pages,cursor;
long end_point,end_lines;
int ci,cj,ck;

unsigned int button_num,mouse_avail,mouse_button=0,mouse_event=0;
unsigned int *mouse_stdptr;
int mouse_x=0,mouse_y=0;



struct clist_cfg
 { char mark[6];
   unsigned main_fc,main_bc;
   unsigned title_fc,title_bc;
   unsigned message_fc,message_bc;
   unsigned win_fc,win_bc;
   unsigned error_fc,error_bc;
   unsigned mouse_main_c,mouse_boundry_c;
   unsigned mouse_outline_c,mouse_hit_outline_c;
   unsigned mouse_fc,mouse_hit_fc;
   unsigned status;
 } c={	     "#CCMP#",
	     7,0,			/* Main color */
	     14,1,			/* Title color */
	     10,1,			/* Message color */
	     0,7,			/* Window color */
	     14,4,			/* Error color */
	     15,0,			/* Mouse main color */
	     8,8,			/* Mouse outline color */
	     2,4,			/* Mouse fill color */
	     3, 			/* Another reverse parameter */
    /* d0 : files menu						      */
    /* d1 : file soring 					      */
    /* d2 ~ d15 reverse 					      */
	    };

void main(int argc,char **argv)
{ int i,j,k;
  char Title[]="Chinese text LISTer. Version 1.12b (1994.3) By L.S.J.(Bugs)";
  vtr=(char *)0xa0000000;
  setcbrk(1);
  ctrlbrk(ctrl_handler);
  test_display();
  chmode=chinese_mode();
  for(j=0,i=1;i<argc;i++)
   { switch(parameter(argv[i]))
      { case 1 : j = 1;break;
	case 2 : c.status = (c.status & 0xfffe) | ((c.status & 0x1)^0x1); /* d0 = 0 ? 1 : 0 */
      }
   }
  if( j == 1 || (argc == 1  && !(c.status&0x1)))
   { if(chmode == 2)
      puts("~Cܵ{1.12b (1994.3) L˳(ww) s@\nϥΡGClist [filename(s)] [/F]\nҦpGClist *.*");
     else
      { puts(Title);
	puts("Usage : clist [filename(s)] [/F]\nExample : clist *.*");
      }
     return;
   }
  puts(Title);
  if(chmode == 2) chinese_mode_ascii();
  if((error_message = (char *)farmalloc(256)) == NULL) return;
  for(i=1;i<argc;i++)
   { k=parameter(argv[i]);
     if(!k)
      { if(clist_files(argv[i],j) == ERROR)
	 { error=1;
	   quit();
	 }
	j=1;
      }
   }
  if(!j)
   { if(clist_files("*.*",0) == ERROR) /* Clist default parameter is *.* */
      { error=1;
	quit();
      }
   }
  quit();
}

int alloc_mem(void)
{int i;
 unsigned font_space[5]={3840,14130,60000,60000,42030};
 char *ptr,*t;
 if((ptr=(char *)farmalloc(MEMORY_ALLOC))==NULL || (t=(char *)farmalloc(10000)) == NULL)
  { farfree(t);
    farfree(ptr);
    strcpy(error_message,"Not enough memory to run clist !\n");
    return(ERROR);
  }
 clist_buffer=ptr;
 for(i=0;i<27;i++)
  clist_lines[i]=ptr+72+i*257;
 clist_line=ptr+6984;
 read_message=ptr+7240;
 error_message=ptr+7496;
 read_buffer=ptr+7496;
 temp=ptr+8521;
 buffer=ptr+8820;
 for(i=0;i<5;i++)
  { if((font_ptr[i]=(char *)farmalloc(font_space[i]))==NULL)
     { farfree(t);
       return(TRUE);
     }
    else
     { if(i == 0) font_load_num=256;
       else font_load_num+=font_space[i]/30;
     }
  }
 farfree(t);
 return(TRUE);
}

void author()
{ int i;
  char *buf;
  unsigned char *lsj[]={
   "~C     ܵ{",
   "vS w",
   "XG1.12b",
   "G83 ~ 3 ",
   "@̡GL˳]jt^",
  };
  if((buf=(char *)farmalloc(imagesize(0,0,16*15,7*16))) == NULL) return;
  getimage(0,MAXY-16*7+1,16*15-1,MAXY,buf);
  draw_window(0,MAXY-16*7+1,16*15-1,MAXY,7);
  for(i=0;i<5;i++)
   clist(16,24*16+i*16,lsj[i],26*8,0,7);
  hit_anykey();
  putimage(0,MAXY-16*7+1,buf,COPY_PUT);
  farfree(buf);
}

/* void bar(int left,int top,int right,int down,unsigned int color)
{ int i,j,k,l;
  unsigned int mask;
  outport(0x3ce,color<<8);
  outport(0x3ce,0x0f01);
  if(left%8)
   { mask=0;
     for(i=8;i<16-left%8;i++)
      mask^=0x01<<i;
     outport(0x3ce,mask|8);
     for(i=top;i<=down;i++)
      *(vtr+i*80+left/8)=0x00;
     outport(0x3ce,0xff08);
     k=left/8-1;
   }
  k=left/8;
  if((right+1)%8)
   { mask=0;
     for(i=0;i<=left%8;i++)
      mask^=0x8000>>i;
     outport(0x3ce,mask|8);
     for(i=top;i<=down;i++)
      *(vtr+i*80+left/8)=0x00;
     outport(0x3ce,0xff08);
     l=right/8-1;
   }
  else l=right/8;
  for(i=top;i<=down;i++)
   for(j=k;j<=l;j++)
    *(vtr+i*80+j)=0x00;
  outport(0x3ce,0x0001);
}
 */

void change_percent(void)
{ int key=0,j,click=FALSE;
  long i;
  long start_percent,percent,old_percent;
  unsigned char *pic;
  if((pic = (unsigned char *)farmalloc(imagesize(624,0,639,431))) == NULL)
   return;
  puts_message("ХLWUηƹӧܦʤI",c.message_fc,c.message_bc,0);
  if(total_bytes)
   i=100*pass_bytes/total_bytes;
  else i=0;
  start_percent=old_percent=percent=i;
  getimage(624,0,639,431,pic);
  draw_percent_bar();
  draw_percent_point(old_percent,percent,c.mouse_outline_c,c.mouse_fc);
  do{ j=1;
   fun_key(key);
   switch(key)
    { case MOUSE_DOWN:
      case DOWN1: if(percent < 100) percent++;
	    break;
      case MOUSE_UP:
      case UP1: if(percent > 0) percent--;
	    break;
      case MOUSE_PAGE_UP:
      case PAGE_UP1: if(percent >= 10) percent -=10;
		     else percent=0;
		     break;
      case MOUSE_PAGE_DOWN:
      case PAGE_DOWN1:if(percent <= 90) percent +=10;
		      else percent = 100;
		      break;
      case MOUSE_FILE_END:
      case CTRL_END:
      case END1:percent = 100;break;
      case MOUSE_START:
      case CTRL_HOME:
      case HOME1: percent=0;break;
      default:j=0;
    }
   if(old_percent != percent ||
      (mouse_x > 624 && mouse_y < 432 && (mouse_y-9)*24/100 != percent))
    { if(j==0) percent = (mouse_y-9)*24/100;
      if(percent > 100) percent = 100;
      if(percent < 0) percent = 0;
      draw_percent_point(old_percent,percent,c.mouse_outline_c,c.mouse_fc);
      draw_percent(percent,1);
      old_percent = percent;
    }
   if(mouse_x > 624 && mouse_y < 432 && mouse_double_click(8,2,0x1))
     click=TRUE;
   }while((key = mygetch(0)) != ESC && key != ENTER &&
	   key != (mouse_button&0x2) && click != TRUE);
  putimage(624,0,pic,COPY_PUT);
  farfree(pic);
  if(mouse_button == 0x2 || key == ESC)
   draw_percent(start_percent,1);
  else
   { if(start_percent > percent) j=-1;
     else j = 1;
     if( percent != start_percent)
      { puts_message("еy I",c.message_fc,c.message_bc,0);
	while(TRUE)
	 { if(search_line(j) == 0 ) break;
	   else
	    { lines+=j;
	      if(total_bytes && tell(ftr)*100/total_bytes*j >= percent*j) break;
	    }
	 }
      }
     i=search_line(27);
     nowy=page_down(0);
     lines+=i + nowy;
   }
  find_file_sit();
  draw_file_sit();
}

int clist(int x,int y,unsigned char *chin,int length,int fcolor,int bcolor)
{long seek;
 register unsigned h,i,l;
 unsigned char high_byte,low_byte;
 char *dp,*dpo;
 setfillstyle(SOLID_FILL,bcolor);
 setcolor(fcolor);
 for(i=0;i<4;i++)
  { if((bcolor>>i)&0x1) b_plan[i]=0xffff;
    else b_plan[i]=0x0000;
  }
 if(x < 0) bar(x,y,x+8-1,y+16-1);
 for(ck=x,ci=0;*(chin+ci) != NULL;ci+=2)
  { high_byte=*(chin+ci),low_byte=*(chin+ci+1);
    cj=x;
    if((high_byte < 0xa1 || high_byte > 0xfe) || ((low_byte < 0x40 ||
	low_byte > 0x7e) && (low_byte < 0xa1 || low_byte > 0xfe)))
     { ci--;
       if(high_byte == '\t')
	{ if(x >= 0) x=((x>>6)+1)<<6;
	  else x=((x+1)/64)*64;      /* int can't shift */
	}
       else x+=8;
       if(x < 0) continue;
       if(x-ck <= length)
	{ if(high_byte != '\t')
	   { if(font_load_num-high_byte >= 0)
	      dp=font_ptr[0]+high_byte*15;
	     else
	      { lseek(font_handle[0],high_byte*15,SEEK_SET);
		read(font_handle[0],clist_buffer,15);
		dp=clist_buffer;
	      }
	     dpo=dp;
	     h=y*80+(cj>>3);
	     for(i=0;i<4;i++)
	      { outport(0x3c4,(0x100<<i)+0x2);
		if((fcolor>>i)&0x1)
		 for(l=h;l<1200+h;dp++,l+=80) *(vtr+l)=(*dp)|b_plan[i];
		else
		 for(l=h;l<1200+h;dp++,l+=80) *(vtr+l)=(~(*dp))&b_plan[i];
		*(vtr+l)=b_plan[i];
		dp=dpo;
	      }
	   }
	  else
	   { outport(0x3c4,0x0f02);
	     bar(cj,y,x,y+16-1);
	   }
	}
       else
	{ outport(0x3c4,0x0f02);
	  bar(cj,y,ck+length-1,y+16-1);
	  return(1);
	}
       if(x >= 640)
	{ outport(0x3c4,0x0f02);
	  return(1);
	}
     }
    else
     { x+=16;
       if(cj < 0) continue;
       if(low_byte >= 0x40 && low_byte <= 0x7e)
	seek = ((int)high_byte-0xa1)*0x9d+((int)low_byte-0x40);
       else
	seek = ((int)high_byte-0xa1)*0x9d+(0x3f+(int)low_byte-0xa1);
       if(seek < 471)
	{ if(font_load_num-256-seek >= 0)
	   dp=font_ptr[1]+seek*30;
	  else
	   { lseek(font_handle[2],seek*30,SEEK_SET);
	     read(font_handle[2],clist_buffer,30);
	     dp=clist_buffer;
	   }
	}
       else if(seek < 5872)
	{ seek-=471;
	  if(font_load_num-728-seek >= 0)
	   { for(h=0;h<3;h++)
	      if(seek < 2000+h*2000)
	       { dp=font_ptr[2+h]+(seek-2000*h)*30;
		 h=3;
	       }
	   }
	  else
	   { lseek(font_handle[1],seek*30,SEEK_SET);
	     read(font_handle[1],clist_buffer,30);
	     dp=clist_buffer;
	   }
	  seek+=471;
	}
       else if(seek >= 5872 && seek <= 6237)
	{ lseek(font_handle[3],(seek-5872)*30,SEEK_SET);
	  read(font_handle[3],clist_buffer,30);
	  dp=clist_buffer;
	}
       else
	{ lseek(font_handle[1],(seek-879)*30,SEEK_SET);
	  read(font_handle[1],clist_buffer,30);
	  dp=clist_buffer;
	}
       if(x-ck <= length)
	{ dpo=dp;
	  h = y*80+(cj>>3);
	  for(i=0;i<4;i++)
	   { outport(0x3c4,(0x100<<i)+0x2);
	     if((fcolor>>i)&0x1)
	      for(l=h;l<h+1200;l+=80)
	       { *(vtr+l)=*dp|b_plan[i];
		 dp++;
		 *(vtr+l+1)=*dp|b_plan[i];
		 dp++;
	       }
	     else
	      for(l=h;l<h+1200;l+=80)
	       { *(vtr+l)=~(*dp)&b_plan[i];
		 dp++;
		 *(vtr+l+1)=~(*dp)&b_plan[i];
		 dp++;
	       }
	     *(vtr+l)=b_plan[i];
	     *(vtr+l+1)=b_plan[i];
	     dp=dpo;
	   }
	  if(seek==146 || seek==206 || (seek >= 208 && seek <= 210) ||
	     seek==213 || seek==215 || seek==216)
	   { outport(0x3c4,0x0f02);
	     line(x-8,y+15,x-9,y+15);
	   }
	}
       else
	{ outport(0x3c4,0x0f02);
	  bar(cj,y,x+length-1,y+16-1);
	  return(1);
	}
      if(x >= 639+16)
       { outport(0x3c4,0x0f02);
	 return(1);
       }
     }
  }
 outport(0x3c4,0x0f02);
 if(x < ck+length)
  bar(x,y,ck+length-1,y+16-1);
 return(TRUE);
}

int clist_file(char *list_file)
{ long s_lines;
  int r_v,hitkey=PAGE_DOWN1,i,j,old_nowy,dela=700,fm;
  unsigned char up_key,down_key,keyflag=1;
  clock_t cd_start,cu_start,c_end;  /* down key start times & up key start times */
  old_nowy=nowy=nowx=up_key=down_key=end_point=end_lines=0;
  lines=pages=pass_bytes=0;
  if((ftr=open(list_file,O_RDONLY|O_BINARY)) == NULL)
   { strcpy(error_message,"Open file error ==>");
     strcat(error_message,list_file);
     return(ERROR);
   }
  buffer_ch[0]=buffer_ch[1]=1;
  lseek(ftr,0,SEEK_END);
  total_bytes=tell(ftr);
  lseek(ftr,0,SEEK_SET);
  draw_mouse(0,9,c.mouse_outline_c,c.mouse_fc);
  draw_total_bytes(0);
  draw_file(list_file);
  file_name=list_file;
  while(kbhit()) ci=getch();
  do{
   if(keyflag)
    { hitkey=mygetch(hitkey);
      keyflag=0;
    }
   else hitkey=mygetch(0);
   fun_key(hitkey);
   switch(hitkey)
   {case CTRL_PAGE_DOWN:keyflag=1;
    case MOUSE_PAGE_DOWN:
    case MOUSE_PAGE_DOWN1:
    case PAGE_DOWN1:
    case PAGE_DOWN2:
	 if(tell(ftr) == total_bytes && total_bytes)
	  { file_message();
	    continue;
	  }
	 draw_mouse(0,6,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 s_lines=search_line(-2);
	 nowy=page_down(nowy);
	 lines += nowy + s_lines;
	 draw_mouse(0,6,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 break;
    case CTRL_PAGE_UP : keyflag=1;
    case MOUSE_PAGE_UP:
    case MOUSE_PAGE_UP1:
    case PAGE_UP1:
    case PAGE_UP2:
	 if(lines <= 27)
	  { file_message();
	    continue;
	  }
	 draw_mouse(0,5,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 j = -25-nowy;
	 if(search_line(j) != j)
	  { lseek(ftr,0,SEEK_SET);
	    nowy=page_down(nowy);
	    lines=27;
	    draw_mouse(0,5,c.mouse_outline_c,c.mouse_fc);
	    fm=1;
	    break;
	  }
	 else
	  { lines -= nowy - 2;
	    nowy=page_down(nowy);
	    if(nowy != 27) lines += 27-nowy;
	  }
	 draw_mouse(0,5,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 break;
    case MINUS: if(dela < 10000) dela += 200;
    case EQUATE:
    case ADD: if(dela > 10) dela -=100;
	      else dela = 0;
	      hitkey=F5;
    case ALT_R:
    case F5: delay(dela);		/* Read mode */
    case CTRL_DOWN: keyflag=1;		/* Continues mode  */
    case MOUSE_DOWN1:
    case MOUSE_DOWN:
    case DOWN1:
    case DOWN2:
	 if(pass_bytes >= total_bytes)
	  { file_message();
	    continue;
	  }
	 /* Ctrl scroll lines = s_lines */
	 c_end = clock();
	 if(c_end-cd_start < 3)
	  {if(down_key < 24) down_key++;
	  }
	 else down_key = 0;
	 if((s_lines = read_lines(1+down_key/8)) == 0) continue;
	 draw_mouse(0,4,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 screen_up(s_lines);
	 if(nowx)
	  { for(i=0;i<s_lines;i++)
	     { line_cur(clist_lines[i],nowx-10);
	       clist(-80,(27-s_lines+i)<<4,clist_lines[i],640+80,c.main_fc,c.main_bc);
	     }
	  }
	 else
	  for(i=0;i<s_lines;i++)
	   clist(0,(27-s_lines+i)<<4,clist_lines[i],640,c.main_fc,c.main_bc);
	 nowy=27;
	 lines+=s_lines;
	 draw_mouse(0,4,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 cd_start = clock();
	 break;
    case CTRL_UP: keyflag=1;		/* Continues mode */
    case MOUSE_UP1:
    case MOUSE_UP:
    case UP1:
    case UP2:
	 if(lines <= 27)
	  { file_message();
	    continue;
	  }
	 c_end = clock();
	 if(c_end-cu_start < 3) 	    /*	< 1/6 second */
	  {if(up_key < 24) up_key++;
	  }
	 else up_key = 0;
	 draw_mouse(0,3,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 s_lines = -nowy-search_line(-1-up_key/8-nowy);
	 read_lines(s_lines);
	 screen_down(s_lines);
	 if(nowx)
	  { for(i=0;i<s_lines;i++)
	     { line_cur(clist_lines[i],nowx-10);
	       clist(-80,i<<4,clist_lines[i],640+80,c.main_fc,c.main_bc);
	     }
	  }
	 else
	  for(i=0;i<s_lines;i++)
	   clist(0,i<<4,clist_lines[i],640,c.main_fc,c.main_bc);
	 nowy = search_line(27-s_lines)+s_lines;
	 if(nowy == 27) lines -= s_lines + nowy - old_nowy;
	 draw_mouse(0,3,c.mouse_outline_c,c.mouse_fc);
	 cu_start = clock();
	 fm=1;
	 break;
    case MOUSE_LEFT1:
    case MOUSE_LEFT:
    case LEFT1:
    case LEFT2:
	 if(!nowx) break;
	 draw_mouse(0,2,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 search_line(-nowy);
	 if(nowx <= 160) nowx-=40;
	 else nowx = 160;
	 page_down(nowy);
	 draw_mouse(0,2,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 break;
    case MOUSE_RIGHT1:
    case MOUSE_RIGHT:
    case RIGHT1:
    case RIGHT2:
	 if(nowx > 160) break;
	 draw_mouse(0,1,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 search_line(-nowy);
	 if(nowx < 160) nowx += 40;
	 else nowx = 176;
	 page_down(0);
	 draw_mouse(0,1,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 break;
    case HOME1:
    case HOME2:
	 if(!nowx) break;
	 nowx=0;
	 search_line(-nowy);
	 page_down(0);
	 fm=1;
	 break;
    case END1:
    case END2:
	 j=0;
	 search_line(-nowy);
	 r_v=read_lines(27);
	 for(i=0;i<r_v;i++)
	 if(true_strlen(clist_lines[i]) > j)
	  j = (int)true_strlen(clist_lines[i]);
	 nowy = r_v;
	 if(j-5 > 0)
	  { if(nowx == j-20) break;
	    if((nowx=(j-20)/40*40) > 176) nowx = 176;
	    search_line(-nowy);
	    page_down(0);
	  }
	 fm=1;
	 break;
    case MOUSE_START:
    case CTRL_HOME:
	 if(lines <= 27) break;
	 draw_mouse(0,7,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 lseek(ftr,0,SEEK_SET);
	 nowy=page_down(0);
	 lines=nowy;
	 fm=1;
	 draw_mouse(0,7,c.mouse_outline_c,c.mouse_fc);
	 break;
    case MOUSE_FILE_END:
    case CTRL_END:
	 draw_mouse(0,8,c.mouse_hit_outline_c,c.mouse_hit_fc);
	 if(to_file_end() == ERROR)
	  { draw_mouse(0,8,c.mouse_outline_c,c.mouse_fc);
	    break;
	  }
	 search_line(-27);
	 nowy=page_down(0);
	 draw_mouse(0,8,c.mouse_outline_c,c.mouse_fc);
	 fm=1;
	 break;
    case MOUSE_SEARCH_LINE:
    case ALT_L:
	 to_search_line();
	 draw_file(list_file);
	 break;
    case F1:
	 search_line(-nowy);
	 help();
	 nowy=page_down(0);
	 break;
    case MOUSE_LOAD_FILES:
    case F3:
	 if(load_files(list_file) == ERROR) break;
	 search_line(-nowy);
	 nowy=page_down(0);
	 break;
    case MOUSE_PERCENT:
    case ALT_P:
	 change_percent();
	 draw_file(list_file);
	 break;
   }
   old_nowy=nowy;
   if(fm)
    { find_file_sit();
      draw_file_sit();
      fm=0;
    }
   }while(hitkey != 27 && hitkey  != MOUSE_ESC);
  draw_mouse(0,9,c.mouse_hit_outline_c,c.mouse_hit_fc);
  close(ftr);
  if(hitkey == MOUSE_ESC) wait_mouse_release(0x1);
  return(TRUE);
}


/* clist muti files menu */
int clist_files(char *list_files,int fun)
{FN ft1,fn,head,last;
 struct ffblk listfiles;
 unsigned char path[81],list_file[14],listfile[81],full_path[83],
	       redraw,keyflag;
 int i,j,k,l,s_num,old_num,old_ptr,f_ptr,hitkey,file_num,l_num;
 if(test_path(list_files,path,full_path) == ERROR)
  return(ERROR);
 re_start:
 redraw=1,keyflag=0;
 for(i=0,l_num=0,file_num=0;;i++)	   // Link direction and files to List
  { if(find_files(&listfiles,full_path,list_file,i,FA_DIREC|FA_RDONLY|FA_HIDDEN) == ERROR) return(ERROR);
    if(list_file[0]==NULL) break;
    if(list_file[0] == '.' && list_file[1] == NULL) continue;
    ft1=fn;
    if((fn = (FN)farmalloc(sizeof(struct files_name))) == NULL)
     { strcpy(error_message,"Not enough memory !");
       return(ERROR);
     }
    ft1->next=fn,fn->ahead=ft1,fn->next=NULL;
    if(listfiles.ff_attrib&0x10)                          // directory
     { fn->file_name[0]='<';
       strcpy((fn->file_name)+1,list_file);
       strcat(fn->file_name,">");
     }
    else			                         // file
     { strcpy(fn->file_name,list_file);
       file_num++;
     }
    l_num++;
    if(l_num == 1) head=fn;
  }
 if(fn == NULL) last=ft1;
 else last=fn;
 if(!fun)
  { if(alloc_mem() == ERROR || open_font_files() == ERROR ||
      load_font_buffer() == ERROR || init_sys() == ERROR)
      return(ERROR);
    Mouse_Init();
    harderr(harderror_handler);
  }
 if(l_num == 1 && !file_num && !fun)
  { strcat(path+ci,(fn->file_name)+1);
    ci=strlen(path);
    path[ci-1] = '\\';
    strcpy(full_path,path);
    strcat(full_path,"*.*");
    fun=1;
    farfree(head);
    goto re_start;
  }
// Sorting files_list
 if(c.status&0x2)
  { for(j=0;j<l_num-1;j++)
     { fn=head;
       ci=0;
       for(k=0;k<l_num-j-1;k++)
	{ if((strcmp(fn->file_name,(fn->next)->file_name) > 0 &&
	      !(fn->file_name[0] == '<' &&
	      fn->next->file_name[0] != '<')) || (fn->file_name[0] != '<' &&
	      fn->next->file_name[0] == '<'))
	   { ft1 = fn->next;
	     if(fn == head) head = fn->next;
	     else  fn->ahead->next = ft1;
	     if(ft1 == last) last=fn;
	     else ft1->next->ahead = fn;
	     ft1->ahead=fn->ahead;
	     fn->ahead=ft1;
	     fn->next=ft1->next;
	     ft1->next=fn;
	     ci++;
	   }
	  else fn=fn->next;
	}
       if(!ci) break;
     }
  }
 if(file_num == 1 && full_path[strlen(full_path)-1] != '*')
  { find_files(&listfiles,full_path,list_file,0,FA_RDONLY|FA_HIDDEN);
    strcpy(listfile,path);
    strcat(listfile,list_file);
    if(clist_file(listfile) == ERROR) return(ERROR);
    draw_mouse(0,9,c.mouse_outline_c,c.mouse_fc);
    return(TRUE);
  }
 ft1=head;
 f_ptr=s_num=old_num=old_ptr=1;
 do{ if(!(c.status&0x1))
      { for(fn=ft1,ci=1;ci<f_ptr;ci++,fn=fn->next);
	while(TRUE)
	 { if(fn->file_name[0] != '<')
	    { strcpy(listfile,path);
	      strcat(listfile,fn->file_name);
	      if(clist_file(listfile) == ERROR) return(ERROR);
	    }
	   if(c.status&0x1) draw_mouse(0,9,c.mouse_outline_c,c.mouse_fc);
	   if(fn->next == NULL || c.status&0x1) break;
	   fn=fn->next;
	 }
	if(!(c.status&0x1)) hitkey=ESC,keyflag=1,redraw=0;
	else redraw=1;
      }
     if(redraw)
      { draw_window(280,0,279+18*8,27*16-1,c.win_bc);
	for(fn=ft1,i=0;i<= l_num && i < 25 && fn != NULL;i++,fn=fn->next)
	 { if(i == f_ptr-1)
	    { clist(296,16+i*16,fn->file_name,8*14,c.win_fc,(c.win_bc-3)%16);
	      files_menu_message(path,fn->file_name,listfile);
	    }
	   else clist(296,16+i*16,fn->file_name,8*14,c.win_fc,c.win_bc);
	 }
	redraw=0;
      }
     if(old_ptr != f_ptr)
      { if(f_ptr > 25)
	 s_num += f_ptr-25,f_ptr = 25;
	else if(f_ptr < 1)
	 s_num -= 1-f_ptr,f_ptr = 1;
      }
     if(old_num != s_num || old_ptr != f_ptr)
      { if(old_num != s_num)
	 { union REGS reg;
	   if(old_num > s_num)
	    { reg.h.ah=0x7;
	      reg.h.bh=7,reg.h.ch=1,reg.h.cl=37,reg.h.dh=25,reg.h.dl=50;
	      reg.h.al=old_num-s_num;
	      int86(0x10,&reg,&reg);
	      for(i=0;i<old_num-s_num;i++,ft1=ft1->ahead);
	      for(fn=ft1,i=0;i<old_num-s_num && i<25;i++,fn=fn->next)
	       if(f_ptr != i+1) clist(296,16+i*16,fn->file_name,8*12,c.win_fc,c.win_bc);
	    }
	   else
	    { reg.h.ah=0x6;
	      reg.h.bh=7,reg.h.ch=1,reg.h.cl=37,reg.h.dh=25,reg.h.dl=50;
	      reg.h.al=s_num-old_num;
	      int86(0x10,&reg,&reg);
	      for(i=0;i<s_num-old_num;i++,ft1=ft1->next);
	      for(fn=ft1,i=0;i<24;i++,fn=fn->next);
	      for(i=24;i>24-s_num+old_num && i >= 0;i--,fn = fn->ahead)
	       if(f_ptr != i+1) clist(296,16+i*16,fn->file_name,8*14,c.win_fc,c.win_bc);
	    }
	 }
	for(fn=ft1,i=0;i<25;i++,fn=fn->next)
	 { if(f_ptr == i+1)
	    { clist(296,16+i*16,fn->file_name,8*14,c.win_fc,(c.win_bc-3)%16);
	      files_menu_message(path,fn->file_name,listfile);
	      i = 25;
	    }
	 }
      }
     old_ptr=f_ptr,old_num=s_num;
     if(keyflag)
      { hitkey=mygetch(hitkey);
	keyflag=0;
      }
     else hitkey=mygetch(0);
     fun_key(hitkey);
     switch(hitkey)
      { case CTRL_UP: keyflag=1;
	case MOUSE_UP:
	case MOUSE_UP1:
	case UP1:
	case UP2: if(s_num != 1 || f_ptr != 1) f_ptr--;
		  break;
	case CTRL_DOWN: keyflag=1;
	case MOUSE_DOWN:
	case MOUSE_DOWN1:
	case DOWN1:
	case DOWN2: if(s_num+f_ptr-1 < l_num) f_ptr++;
		    break;
	case MOUSE_PAGE_UP:
	case MOUSE_PAGE_UP1:
	case PAGE_UP1:
	case PAGE_UP2: delay(40);
		       if(f_ptr != 1)
			{ f_ptr = 1;break;
			}
		       if(s_num > 25) s_num -=24;
		       else s_num = 1;
		       break;
	case MOUSE_PAGE_DOWN:
	case MOUSE_PAGE_DOWN1:
	case PAGE_DOWN1:
	case PAGE_DOWN2: delay(40);
			 if(f_ptr != 25)
			  { if(l_num < 25) f_ptr = l_num;
			    else f_ptr=25;
			  }
			 else if(s_num < l_num - 49) s_num +=24;
			 else s_num = l_num -24;
			 break;
	case MOUSE_START:
	case CTRL_HOME:
	case HOME1 :
	case HOME2 : s_num = 1,f_ptr=1;break;
	case MOUSE_FILE_END:
	case CTRL_END:
	case END1 :
	case END2 : if(file_num > 25)
		     { s_num = file_num-24,f_ptr=25;
		     }
		    else f_ptr=l_num;
		    break;
	case MOUSE_LEFT:
	case MOUSE_LEFT1:
	case LEFT1:
	case LEFT2:
	case MOUSE_RIGHT:
	case MOUSE_RIGHT1:
	case RIGHT1:
	case RIGHT2:if(hitkey == MOUSE_LEFT || hitkey == MOUSE_LEFT1 ||
		       hitkey == LEFT1 || hitkey == LEFT2)
		     j=toupper(path[0])-66,k=(biosequip()>>6)&0x3,l=-1;
		    else
		     j=toupper(path[0])-64,k=26,l=1;
		    for(cj=getdisk(),setdisk(j-1),i=j;i != k ;i+=l)
		     { ci=getdisk();
		       setdisk(i);
		       ck=getdisk();
		       if(ci!=ck) break;
		     }
		    if(i != k)
		     { path[0]=full_path[0]='a'+ck;
		       path[2]=full_path[2]=NULL;
		       strcat(full_path,"*.*");
		       fun=1;
		       setdisk(cj);
		       wait_mouse_release(0x3);
		       test_path(full_path,path,full_path);
		       free_file_list(head,last);
		       goto re_start;
		     }
		    setdisk(cj);
		    break;
	case MOUSE_LOAD_FILES:
	case F3: strcpy(read_message,"пJɮצW١G");
		 puts_message(read_message,c.message_fc,c.message_bc,3);
		 if(*read_message == NULL)
		  { files_menu_message(path,fn->file_name,listfile);
		    break;
		  }
		 else
		  { if(test_path(read_message,read_message,full_path) == ERROR ||
		       find_files(&listfiles,full_path,list_file,0,FA_RDONLY|FA_HIDDEN|FA_DIREC) == ERROR)
		     { puts_message("Jɮ׿~I",c.error_fc,c.error_bc,2);
		       test_path(path,path,full_path);
		       draw_file(listfile);
		       continue;
		     }
		    else
		     {	fun=1;
			free_file_list(head,last);
			test_path(full_path,path,full_path);
			goto re_start;
		     }
		  }
	case 256*2+1: i=0;		         // Mouse_button != 0
		      if(mouse_x >= 304 && mouse_x <=400 && mouse_y >= 16 &&
			 mouse_y < 416 && mouse_button ==  0x1)
		       { if(s_num + (mouse_y>>4) -1 <= l_num )
			  { if(f_ptr != (mouse_y>>4))
			      { for(f_ptr=mouse_y>>4,fn=ft1,ci=0;ci< f_ptr-1;ci++,fn=fn->next);
				files_menu_message(path,fn->file_name,listfile);
			      }
			    else if(mouse_double_click(8*3,2,1)) i=1;
			  }
		       }
		      else break;
		      if(!i) break;
	case ENTER :
	case SPACE : cj=strlen(listfile);
		     if(listfile[cj-1] == '>')
		      { for(i=cj-1;i >= 0 && listfile[i] != '\\';i--);
			strcpy(listfile+i+1,listfile+i+2);
			listfile[cj-2]=NULL;
			if(listfile[i+1]== '.')
			 { for(i=strlen(path)-2;i>=0;i--)
			    { if(path[i] == '\\')
			       path[i+1]=NULL,i=-1;
			    }
			 }
			else
			 { strcat(path,listfile+i+1);
			   strcat(path,"\\");
			 }
			strcpy(full_path,path);
			strcat(full_path,"*.*");
			fun=1;
			free_file_list(head,last);
			goto re_start;
		      }
		     if(clist_file(listfile) == ERROR) return(ERROR);
		     draw_mouse(0,9,c.mouse_outline_c,c.mouse_fc);
		     if(f_ptr > 1) old_ptr=1;
		     else old_ptr=2;
		     redraw=1;
		     break;
	case MOUSE_FILE_MENU:
	case ALT_F : redraw=1;break;
	default : if(hitkey >= 33 && hitkey <= 126)
		   { if(hitkey >= 97 && hitkey <= 122) hitkey-=32;
		     for(fn=ft1,i=1;i<f_ptr;i++,fn=fn->next);
		     for(i=1;i<l_num;i++)
		      { fn = fn->next;
			if(fn == NULL) fn=head;
			if(fn->file_name[0] == hitkey) f_ptr+=i,i=l_num;
		      }
		     if(f_ptr+s_num > l_num+1)
		      f_ptr=f_ptr+s_num-l_num-1,s_num=1;
		   }
      }
     if(f_ptr != old_ptr || old_num != s_num)
      { for(fn=ft1,i=0;i<25;i++,fn=fn->next)
	 { if(old_ptr == i+1)
	    { clist(296,16+i*16,fn->file_name,8*14,c.win_fc,c.win_bc);
	      i = 25;
	    }
	 }
      }
   }while(hitkey != ESC && hitkey != MOUSE_ESC);
 free_file_list(head,last);
 return(TRUE);
}

int ctrl_handler(void)
{ quit();
  return;
}

void draw_cur(int sit)
{ if(sit == 0)
   clist(64,MAXY-31,"ơG",48,c.title_fc,c.title_bc);
  l_to_s(temp,nowx+1);
  clist(112,MAXY-31,temp,32,c.title_fc,c.title_bc);
}

void draw_down(int draw_color,int fill_color)
{ int down[]=
    {490+10,MAXY-21,490+10,MAXY-12,490+2,MAXY-12,490+15,MAXY-1,
     490+28,MAXY-12,490+20,MAXY-12,490+20,MAXY-21,490+10,MAXY-21};
  setcolor(draw_color);
  drawpoly(8,down);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(490+11,MAXY-20,draw_color);
}

void draw_end(int draw_color,int fill_color)
{ int end[] =
    {550+10,MAXY-21,550+10,MAXY-15,550+2,MAXY-15,550+15,MAXY-7,
     550+28,MAXY-15,550+20,MAXY-15,550+20,MAXY-21,550+10,MAXY-21};
  int page_5point[] =
    { 550+2,MAXY-1,550+2,MAXY-5,550+27,MAXY-5,550+27,MAXY-1,
      550+2,MAXY-1};
  setcolor(draw_color);
  setfillstyle(SOLID_FILL,fill_color);
  drawpoly(8,end);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(550+11,MAXY-20,draw_color);
  drawpoly(5,page_5point);
  floodfill(550+3,MAXY-2,draw_color);
}

void draw_esc(int draw_color,int fill_color)
{ int esc[] =
    {580+12,MAXY-35,580+12,MAXY-40,580+6,MAXY-40,580+15,MAXY-46,
     580+24,MAXY-40,580+18,MAXY-40,580+18,MAXY-35,580+27,MAXY-35,
     580+27,MAXY-26,580+2,MAXY-26,580+2,MAXY-35,580+12,MAXY-35};
  setcolor(draw_color);
  drawpoly(12,esc);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(580+3,MAXY-27,draw_color);
}


void draw_file(unsigned char *list_file)
{ unsigned char f_n[64]="ɮצW١G";
  if((ci=strlen(list_file)) > 49)
   { for(cj=ci;cj>=0;cj--)
      if(*(list_file+cj) == 92) break;
     strcat(f_n,"...");
     strcat(f_n,list_file+cj);
   }
  else strcat(f_n,list_file);
  for(cj=10;cj<strlen(f_n);cj++)
   f_n[cj]=tolower(f_n[cj]);
  puts_message(f_n,c.message_fc,c.message_bc,0);
}
void draw_file_sit(void)
{ static long old_lines,old_pass_bytes,old_pages,old_percent;
  static int old_cur;
  if(old_lines != lines) draw_lines(1);
  if(old_pass_bytes != pass_bytes) draw_pass_bytes(1);
  if(old_pages != pages) draw_pages(1);
  if(total_bytes && old_percent != pass_bytes*100/total_bytes) draw_percent(pass_bytes*100/total_bytes,1);
  if(old_cur != nowx+1) draw_cur(1);
  old_lines=lines,old_pass_bytes=pass_bytes,old_pages=pages;
  if(total_bytes) old_percent=pass_bytes*100/total_bytes;
  else old_percent=0;
  old_cur=nowx+1;
}

void draw_file_menu(int fcolor)
{ if(c.status&0x1)
   clist(580+12,MAXY-18,"F",8,fcolor,c.mouse_main_c);
  else
   clist(580+12,MAXY-18,"f",8,fcolor,c.mouse_main_c);
}

void draw_left(int draw_color,int fill_color)
{ int left[]=
    {460+27,MAXY-15,460+16,MAXY-15,460+16,MAXY-22,460+2,MAXY-11,
     460+16,MAXY-1,460+16,MAXY-7,460+27,MAXY-7,460+27,MAXY-15};
  setcolor(draw_color);
  drawpoly(8,left);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(460+26,MAXY-10,draw_color);
}

void draw_lines(int sit)
{ if(!sit)
   clist(64,MAXY-47,"CơG",6*8,c.title_fc,c.title_bc);
  l_to_s(temp,lines);
  clist(64+8*6,MAXY-47,temp,8*8,c.title_fc,c.title_bc);
}

void draw_mark(void)
{ int i;
  int data[2][3]={{0,5,30},{72,32,42}};
  unsigned char mark[72*2]=
   {   0,  0,  0,  0,  0, 64,  0,  0, 64,  0,  0, 64,  4,  8, 64,  2,  8,248,
       2, 14,128,  4,  8,  0,  0,  0, 32,  0,  1,176,  0, 14, 32,  8, 16, 64,
       8, 16,192,  8,  3,  0,  8,  1, 64,  8,  3,  0, 16,  2,  0, 16,  2,248,
      20, 14,  0, 28,102,  0, 24,  4, 32, 24,  8, 16,  0,  0, 24,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0, 56,  0,112, 12,  1,240, 12,  7,224, 12,
      28,192, 12,  0,128, 12,  1,  0, 12,  3,  3,  8,  2,131,  8,  4,227, 12,
       8, 67, 12, 25,195, 12, 55,192, 12, 60,192, 12,  0,128, 12,  1,128, 12,
       1,128, 12,  3,  0, 12,  6,  0, 28, 16,  0, 12,  0,  0,  8,  0,  0,  0
   };
  setfillstyle(SOLID_FILL,7);
  bar(0,MAXY-47,63,MAXY);
  setcolor(8);
  for(i=0;i<5;i++)
   { line(i,MAXY-i,63,MAXY-i);
     line(63-i,MAXY-47+i,63-i,MAXY);
   }
  setcolor(15);
  for(i=0;i<5;i++)
   { line(i,MAXY-47+i,63-i,MAXY-47+i);
     line(i,MAXY-47,i,MAXY-i);
   }
  for(ci=0;ci<2;ci++)
  for(i=0,ck=0;i<24;i++)
  { for(cj=0;cj<24;cj++)
     { if((mark[data[ci][0]+i*3+cj/8] >>(7-cj%8))&0x1)
	{ if(ck!=1)
	    putpixel(data[ci][1]+cj-1,MAXY-data[ci][2]+i,15);
	  putpixel(data[ci][1]+cj,MAXY-data[ci][2]+i,8);
	  ck=1;
	}
       else if(ck==1)
	ck=0;
     }
    ck=3;
  }
}

void draw_more(int draw_color,int fill_color)
{ int more_5point[10];
  setcolor(draw_color);
  setfillstyle(SOLID_FILL,fill_color);
  for(ci=0;ci<4;ci++)
   { more_5point[0]=612+ci*7,more_5point[1]=MAXY-3;
     more_5point[2]=612+ci*7,more_5point[3]=MAXY-7;
     more_5point[4]=616+ci*7,more_5point[5]=MAXY-7;
     more_5point[6]=616+ci*7,more_5point[7]=MAXY-3;
     more_5point[8]=612+ci*7,more_5point[9]=MAXY-3;
     drawpoly(5,more_5point);
     floodfill(613+ci*7,MAXY-5,draw_color);
   }
}
void draw_mouse(int sit,int fun,int draw_color,int fill_color)
{ if(!sit && !fun)
   { draw_right(c.mouse_outline_c,c.mouse_fc);
     draw_left(c.mouse_outline_c,c.mouse_fc);
     draw_up(c.mouse_outline_c,c.mouse_fc);
     draw_down(c.mouse_outline_c,c.mouse_fc);
     draw_page_up(c.mouse_outline_c,c.mouse_fc);
     draw_page_down(c.mouse_outline_c,c.mouse_fc);
     draw_start(c.mouse_outline_c,c.mouse_fc);
     draw_end(c.mouse_outline_c,c.mouse_fc);
     draw_esc(c.mouse_outline_c,c.mouse_fc);
     draw_file_menu(c.mouse_fc);
     draw_quit(c.mouse_fc);
     draw_more(c.mouse_outline_c,c.mouse_fc);
   }
  else if(!sit)
   { switch(fun)
      { case 1 : draw_right(draw_color,fill_color);break;
	case 2 : draw_left(draw_color,fill_color);break;
	case 3 : draw_up(draw_color,fill_color);break;
	case 4 : draw_down(draw_color,fill_color);break;
	case 5 : draw_page_up(draw_color,fill_color);break;
	case 6 : draw_page_down(draw_color,fill_color);break;
	case 7 : draw_start(draw_color,fill_color);break;
	case 8 : draw_end(draw_color,fill_color);break;
	case 9 : draw_esc(draw_color,fill_color);break;
	case 10: draw_file_menu(fill_color);break;
	case 11: draw_quit(fill_color);
	case 12: draw_more(draw_color,fill_color);
      }
   }
}

void draw_pages(int sit)
{ if(!sit)
   clist(64+8*17,MAXY-47,"ơG",6*8,c.title_fc,c.title_bc);
  l_to_s(temp,pages);
  clist(64+8*23,MAXY-47,temp,7*8,c.title_fc,c.title_bc);
}
void draw_page_down(int draw_color,int fill_color)
{ int page_down[] =
    { 520+10,MAXY-16,520+10,MAXY-10,520+2,MAXY-10,520+15,MAXY-1,
      520+28,MAXY-10,520+20,MAXY-10,520+20,MAXY-16,520+10,MAXY-16};
  int page_5point[] =
    { 520+10,MAXY-18,520+10,MAXY-21,520+20,MAXY-21,520+20,MAXY-18,
      520+10,MAXY-18};
  setcolor(draw_color);
  drawpoly(8,page_down);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(520+11,MAXY-15,draw_color);
  drawpoly(5,page_5point);
  floodfill(520+11,MAXY-20,draw_color);
}

void draw_page_up(int draw_color,int fill_color)
{ int page_up[] =
    {520+10,MAXY-31,520+10,MAXY-37,520+2,MAXY-37,520+15,MAXY-46,
     520+28,MAXY-37,520+20,MAXY-37,520+20,MAXY-31,520+10,MAXY-31};
  int page_5point[] =
    { 520+10,MAXY-25,520+10,MAXY-28,520+20,MAXY-28,520+20,MAXY-25,
      520+10,MAXY-25};
  setcolor(draw_color);
  drawpoly(8,page_up);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(520+11,MAXY-33,draw_color);
  drawpoly(5,page_5point);
  floodfill(520+11,MAXY-26,draw_color);
}

void draw_pass_bytes(int sit)
{ if(!sit)
   clist(64+34*8,MAXY-31,"ZG",6*8,c.title_fc,c.title_bc);
  if((pass_bytes>>10) >= 10000)
   { l_to_s(temp,(pass_bytes>>10));
     strcat(temp,"K");
   }
  else
   l_to_s(temp,pass_bytes);
  clist(64+40*8,MAXY-31,temp,7*8,c.title_fc,c.title_bc);
}

void draw_percent(long percent,int sit)
{ if(!sit)
   clist(64+8*32,MAXY-47,"ʤG",8*8,c.title_fc,c.title_bc);
  l_to_s(temp,percent);
  clist(64+8*40,MAXY-47,temp,4*8,c.title_fc,c.title_bc);
}

void draw_percent_bar(void)
{ int point5[]=
   {624,0,639,0,639,431,624,431,624,0};
  setfillstyle(SOLID_FILL,c.mouse_main_c);
  bar(625,0,638,431);
  setcolor(c.mouse_boundry_c);
  drawpoly(5,point5);
}

void draw_percent_point(long old_percent,long percent,int draw_color,int fill_color)
{ long pp[2];
  int point5[10];
  pp[0]=old_percent,pp[1]=percent;
  for(ci=0;ci<2;ci++)
   { if(!ci)
      setfillstyle(SOLID_FILL,c.mouse_main_c);
     else
      setfillstyle(SOLID_FILL,fill_color);
     bar(626,pp[ci]*415/100+2,637,pp[ci]*415/100+15);
     if(!ci)
      setcolor(c.mouse_main_c);
     else
      setcolor(draw_color);
     point5[0]=point5[6]=point5[8]=625;
     point5[1]=point5[3]=point5[9]=pp[ci]*415/100+1;
     point5[2]=point5[4]=638;
     point5[5]=point5[7]=pp[ci]*415/100+16;
     drawpoly(5,point5);
   }
}

void draw_quit(int fcolor)
{ clist(616,MAXY-40,"Dos",3*8,fcolor,c.mouse_main_c);
}

void draw_right(int draw_color,int fill_color)
{ int right[]=
    {460+2,MAXY-39,460+14,MAXY-39,460+14,MAXY-46,460+28,MAXY-35,
     460+14,MAXY-24,460+14,MAXY-31,460+2,MAXY-31,460+2,MAXY-39};
  setcolor(draw_color);
  drawpoly(8,right);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(460+3,MAXY-34,draw_color);
}

void draw_start(int draw_color,int fill_color)
{ int start[] =
    {550+10,MAXY-25,550+10,MAXY-31,550+2,MAXY-31,550+15,MAXY-40,
     550+28,MAXY-31,550+20,MAXY-31,550+20,MAXY-25,550+10,MAXY-25};
  int page_5point[] =
    { 550+2,MAXY-42,550+2,MAXY-46,550+27,MAXY-46,550+27,MAXY-42,
      550+2,MAXY-42};
  setcolor(draw_color);
  setfillstyle(SOLID_FILL,fill_color);
  drawpoly(8,start);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(550+11,MAXY-26,draw_color);
  drawpoly(5,page_5point);
  floodfill(550+3,MAXY-43,draw_color);
}

void draw_total_bytes(int sit)
{ if(!sit)
   clist(64+13*8,MAXY-31,"ɮתסG",10*8,c.title_fc,c.title_bc);
  if((total_bytes>>10) > 10000)
   { l_to_s(temp,(total_bytes>>10));
     strcat(temp,"K");
   }
  else
   l_to_s(temp,total_bytes);
  clist(64+23*8,MAXY-31,temp,8*8,c.title_fc,c.title_bc);
}

void draw_up(int draw_color,int fill_color)
{ int up[]=
   { 490+10,MAXY-25,490+10,MAXY-34,490+2,MAXY-34,490+15,MAXY-46,
     490+28,MAXY-34,490+20,MAXY-34,490+20,MAXY-25,490+10,MAXY-25};
  setcolor(draw_color);
  drawpoly(8,up);
  setfillstyle(SOLID_FILL,fill_color);
  floodfill(490+11,MAXY-26,draw_color);
}

void draw_title(void)
{ setfillstyle(SOLID_FILL,c.title_bc);
  bar(0,MAXY-47,459,MAXY);
  setfillstyle(SOLID_FILL,c.mouse_main_c);
  bar(460,MAXY-47,MAXX,MAXY);
  setcolor(c.mouse_boundry_c);
  for(ci=1;ci<6;ci++)
   line(MAXX-180+30*ci,MAXY-47,MAXX-180+30*ci,MAXY);
  line(MAXX-180,MAXY-23,MAXX,MAXY-23);
  setfillstyle(SOLID_FILL,c.main_bc);
  bar(0,0,MAXX,MAXY-48);
  draw_mark();
  draw_mouse(0,0,c.mouse_outline_c,c.mouse_fc);
  draw_lines(0);
  draw_cur(0);
  draw_pages(0);
  draw_percent(0,0);
  draw_total_bytes(0);
  draw_pass_bytes(0);
}

void draw_window(int left,int top,int right,int down,int bcolor)
{ int wd[26];
  wd[0]= wd[6] =wd[8] =wd[22]=wd[24]=left+5;
  wd[2]= wd[4] =left+10;
  wd[1]= wd[3] =wd[17]=wd[19]=wd[25]=top+5;
  wd[21]=wd[23]=top+10;
  wd[5]= wd[7] =wd[13]=wd[15]=down-5;
  wd[9]= wd[11]=down-10;
  wd[10]=wd[12]=wd[18]=wd[20]=right-5;
  wd[14]=wd[16]=right-10;
  setfillstyle(SOLID_FILL,7);
  bar(left,top,right,top+15);
  bar(left,top,left+15,down);
  bar(left,down-15,right,down);
  bar(right-15,top,right,down);
  setfillstyle(SOLID_FILL,bcolor);
  bar(left+16,top+16,right-16,down-16);
  setcolor(8);
  drawpoly(13,wd);
  setcolor(15);
  for(ci=0;ci<26;ci++)
   wd[ci]--;
  drawpoly(13,wd);
}

void file_message(void)
{ char fm[2][11]={"ɮ׶}YI","ɮ׵I"};
  ci=10;
  if(tell(ftr) == total_bytes)
   ci=1;
  if(lines <= 27)
   ci=0;
  if(ci != 10) puts_message(fm[ci],c.message_fc,c.message_bc,4);
}

void files_menu_message(char *path,char *filename,char *listfile)
{ strcpy(listfile,path);
  strcat(listfile,filename);
  if((ftr=open(listfile,O_RDONLY|O_BINARY)) == -1) total_bytes = 0;
  else
   { lseek(ftr,0,SEEK_END);
     total_bytes=tell(ftr);
     close(ftr);
   }
  draw_total_bytes(0);
  draw_file(listfile);
}

int find_files(struct ffblk *listfiles,unsigned char *list_files,unsigned char *list_file,int times,int mode)
{*list_file=NULL;
 if(!times)
  { if(findfirst(list_files,listfiles,mode) != 0)
     { strcpy(error_message,"Not such file(s) or directory ==> ");
       strcat(error_message,list_files);
       return(ERROR);
     }
    else
     strcpy(list_file,listfiles->ff_name);
  }
 else if(!findnext(listfiles))
  strcpy(list_file,listfiles->ff_name);
 return(TRUE);
}

void find_file_sit(void)
{ if(lines/10000 >= 1000 ) lines=10000*1000;
  pass_bytes=tell(ftr);
  pages=(lines-1)/PAGE_LINES+1;
}

void free_file_list(FN head,FN last)
{FN fn,ft1;
 fn=head;
 while(fn != last)
  { ft1=fn;
    farfree(fn);
    fn=ft1->next;
  }
 farfree(fn);
}

void fun_key(int hitkey)
{ switch(hitkey)
   { case MOUSE_FILE_MENU: wait_mouse_release(0x1);
     case ALT_F : c.status = (c.status & 0xfffe) | ((c.status & 0x1)^0x1); /* d0 = 0 ? 1 : 0 */
		  draw_file_menu(c.mouse_fc);
		  if(c.status&0x1) puts_message("ɮ׿}ҡI",c.message_fc,c.message_bc,4);
		  else puts_message("ɮ׿I",c.message_fc,c.message_bc,4);
		  break;
     case MOUSE_QUIT :
     case ALT_Q :quit();
     case MOUSE_AUTHOR :
     case F11 : author();break;
     case ALT_S : c.status = (c.status & 0xfffd) |((c.status &0x2)^0x2); /* d1 = 0 ? 1 : 0 */
		if(c.status&0x2) puts_message("ɮױƧǶ}ҡI",c.message_fc,c.message_bc,4);
		else puts_message("ɮױƧI",c.message_fc,c.message_bc,4);
		break;
   }
}

int ggets(int x,int y,unsigned char *str,int width,int fcolor,int bcolor)
{unsigned ch,ch_now=0,old_ch=0,max_point=0;
 clock_t times;
 *str=NULL;
 setfillstyle(SOLID_FILL,bcolor);
 do
  { times=clock();
    ch=mygetch(257);
    if(mouse_avail)
     { if(ch == 257 || old_ch != ch) Mouse_Show();
       else if(ch != 257 && old_ch == 257) Mouse_Hide();
     }
    fun_key(ch);
    switch(ch)
     { case BACKSPACE: if(max_point > 0)
			{ if(ch_now)
			   { strcpy(str+ch_now-1,str+ch_now);
			     ch_now--;
			   }
			  else
			   strcpy(str,str+1);
			  max_point--;
			  clist(x+(ch_now<<3),y,str+ch_now,width-(ch_now<<3),fcolor,bcolor);
			}
		       break;
       case HOME1: ch_now=0;
		   break;
       case END1: ch_now=max_point;
		  break;
       case ENTER: *(str+max_point)=NULL;
		   return(0);
       case MOUSE_RIGHT:delay(50);
       case RIGHT1:if(ch_now < max_point) ch_now++;
		  break;
       case MOUSE_LEFT:delay(50);
       case LEFT1:if(ch_now) ch_now--;
		  break;
       default: if(x+max_point*8 < x+width && ch <= 256)
		 { strcpy(temp,str+ch_now);
		   *(str+ch_now)=ch;
		   strcpy(str+ch_now+1,temp);
		   *(str+max_point+1)=NULL;
		   clist(x+(ch_now<<3),y,str+ch_now,width-(ch_now<<3),fcolor,bcolor);
		   if(x+(max_point<<3) < x+width-8)
		    { ++ch_now;
		      ++max_point;
		    }
		 }
     }
    if(ch != 257)
     { setcolor(bcolor);
       line(x+(old_ch<<3),y+15,x+(old_ch<<3)+7,y+15);
     }
    if((times>>2)%2)				 /* Software  cursor */
     { setcolor(bcolor);			 /* Cursor is off    */
       line(x+(ch_now<<3),y+15,x+(ch_now<<3)+7,y+15);
     }
    else
     { setcolor(fcolor);
       line(x+(ch_now<<3),y+15,x+(ch_now<<3)+7,y+15);  /* Cursor is on      */
     }
    old_ch=ch_now;
  }while(ch != 27 && ch != MOUSE_ESC && ch != MOUSE_BREAK);
  *(str)=NULL;
  bar(x,y,x+(ch_now<<3),y+15);
  return(-1);
}

int harderror_handler(int errorcode,int deverror,int bpval,int sival)
{ sound(700);
  delay(300);
  nosound();
  if((errorcode & 0xff) == DRIVE_NOT_READY)
   { *error_message = 'A' +(deverror & 0xff);
     *(error_message+1) = NULL;
     strcat(error_message," ϺоƧI Ы@~I");
     puts_message(error_message,c.error_fc,c.error_bc,1);
     error_flag=1;
   }
  else
   { puts_message("Ū~I Ы@~I",c.error_fc,c.error_bc,1);
     error_flag=2;
   }
  hardretn(0);
}

void help(void)
{ unsigned i;
  unsigned char *help_message[]=
{"~C ܵ{U ^ = Ctrl A@ = Alt A# = Shift " ,
 "zwwwwwwwwwwswwwwwwwwwwwwswwwwwwwwwww{",
 "x 8     VW     x^Home      ɮ׶}Y     x#R  F5 ۰ܼҦ x",
 "x 2     VU     x^End       ɮ׵     x#S       ɮױƧ x",
 "x 4     V     x^Up        ۰ʤW     x#F       ɮ׿ x",
 "x 6     Vk     x^Down      ۰ʤU     xF1       Help         x",
 "xPageUp     VW@ x^PageUp    ۰PageUp   xF3       Ūɮ     x",
 "xPageDown   VU@ x^PageDown  ۰PageDown xF11      {     x",
 "xHome       ̥   x#Q         }         x                      x",
 "xEnd        ̥k   x#P         ɮ%    x                      x",
 "xEsc        } x#L         ɮצC x                      x",
 "|wwwwwwwwwwrwwwwwwwwwwwwrwwwwwwwwwww}"
 };
  draw_window(0,0,MAXX,16*16,c.win_bc);
  for(i=0;i<12;i++)
   clist(16,(i+1)<<4,help_message[i],640-32,c.win_fc,c.win_bc);
  hit_anykey();
  mygetch(0);
}

void hit_anykey(void)
{ Mouse_Show();
  while(TRUE)
   if(kbhit() || mouse_button) break;
  Mouse_Hide();
}

int init_sys(void)
{ int gd=VGA,gm=VGAHI;
  if(registerfarbgidriver(EGAVGA_driver_far) < 0)
   { strcpy(error_message,"Error registering EGAVGA driver !");
     return(ERROR);
   }
  initgraph(&gd,&gm,"");
  graph_mode=1;
  draw_title();
  return(TRUE);
}

int l_to_s(unsigned char *str,long long1)
{ char buf[12];
  for(ci=11;ci>=0;ci--)
   if(long1/10)
    { if(long1 > 0) buf[ci]=48+long1%10;
      else buf[ci] = 48-long1%10;
      long1 /=10;
    }
   else
    { if(long1 >= 0) buf[ci]=48+long1;
      else
       { buf[ci]=48-long1;
	 buf[--ci]='-';
       }
      break;
    }
  for(cj=11;cj>=ci;cj--)
   { ck=11-cj;
     *(str+ck)=buf[ci+ck];
   }
  *(str+11-cj)=NULL;
  return(cj);
}

void line_cur(unsigned char *line,int startat)
{ unsigned now_length,ck=strlen(line);
  temp[0]=NULL;
  for(ci=0,now_length=0;ci<ck;ci++)
   { if(*(line+ci) == '\t')
      { now_length=((now_length>>3)+1)<<3;
	if(now_length > startat)
	 { for(cj=0;cj<now_length-startat;cj++)
	    temp[cj]=SPACE;
	   strcpy(temp+cj,line+ci+1);
	   strcpy(line,temp);
	   return;
	 }
      }
     else now_length++;
     if((now_length-1) == startat)
      { strcpy(line,line+ci);
	return;
      }
     else if(ci == ck-1)
      { *line=NULL;
	return;
      }
   }
}

int load_files(unsigned char *list_file)
{int old_ftr,oldx,oldy;
 long old_lines,old_total_bytes,old_pass_bytes,old_pages,old_cursor,
      old_end_point,old_end_lines;
 old_ftr=ftr,oldx=nowx,oldy=nowy,old_lines=lines,old_total_bytes=total_bytes;
 old_pass_bytes=pass_bytes,old_pages=pages,old_cursor=cursor;
 old_end_point=end_point,old_end_lines=end_lines;
 puts_message("пJɮצW١G",c.message_fc,c.message_bc,3);
 if( *read_message == NULL)
  { draw_file(list_file);
    return(ERROR);
  }
 for(ci=0;ci<strlen(read_message);ci++)
  if(*(read_message+ci) != '\t' || *(read_message+ci) != SPACE) break;
 strcpy(read_message,read_message+ci);
 for(ci=strlen(read_message);ci>=0;ci--)
  if(*(read_message+ci) != '\t' || *(read_message+ci) != SPACE) break;
 *(read_message+ci+1) = NULL;
 if(clist_files(read_message,1) == ERROR)
  puts_message("J~GLɮסI",c.error_fc,c.error_bc,1);
 draw_mouse(0,0,c.mouse_outline_c,c.mouse_fc);
 nowx=oldx,nowy=oldy,lines=old_lines,total_bytes=old_total_bytes;
 pass_bytes=old_pass_bytes,pages=old_pages,cursor=old_cursor;
 end_point=old_end_point,end_lines=old_end_lines;
 ftr=old_ftr;
 draw_file_sit();
 draw_total_bytes(1);
 draw_file(list_file);
 buffer_ch[0]=buffer_ch[1]=1;
 return(TRUE);
}

int load_font_buffer(void)
{ long l=font_load_num;
  unsigned font_space[5]={3840,12240,60000,60000,42030};
  int handle[5]={0,2,1,1,1};
  for(ci=0;ci<5;ci++)
   { if(ci == 0) l-=256;
     else if(ci == 1)l-=471;
     else l-=font_space[ci]/30;
     if(l >= 0)
      { if(read(font_handle[handle[ci]],font_ptr[ci],font_space[ci]) != font_space[ci])
	 { strcpy(error_message,"Loading Chinese's font data error !\n");
	   return(ERROR);
	 }
      }
     else break;
   }
  return(TRUE);
}

int mygetch(int def)
{ unsigned char ch1=0,ch2=0;
  int mouse_r_v;
  if(def && !mouse_button && !kbhit()) return(def);
  if((mouse_r_v=run_mouse()) > 0 ) return(2*256+mouse_r_v);
  setcbrk(0);
  while(kbhit())
   { ch1 = getch();
     if(ch1 == 0)
      ch2=getch();
   }
  setcbrk(1);
  if(ch1 != 0 || ch2 != 0)
   { if(ch1)
       return((int)ch1);
     else
       return((int)256+ch2);
   }
  else return(0);
}

/* This function like Cache (read buffer) */
int my_read(int ftr,int read_size)
{ int i;
  long k,point=tell(ftr);
  for(i=0;i<2;i++)
   { if(!buffer_ch[i])
      { if(point >= buffer_point[i] && point-buffer_point[i] < 5120-read_size)
	 { k=i*5120+point-buffer_point[i];
	   rb = buffer+k;
	   if(buffer_size[i] != 5120 && point+read_size >= buffer_point[i]+buffer_size[i])
	    read_size=buffer_point[i]+buffer_size[i]-point;
	   lseek(ftr,point+read_size,SEEK_SET);
	   return(read_size);
	 }
	else if(i)
	 { if(point > buffer_point[0] && buffer_point[0] > buffer_point[1])
	    { buffer_point[1]=point;
	      buffer_size[1]=myread(ftr,buffer+5120,5120);
	      i=0;
	    }
	   else if(point > buffer_point[1] && buffer_point[1] > buffer_point[0])
	    { buffer_point[0]=point;
	      buffer_size[0]=myread(ftr,buffer,5120);
	      i=-1;
	    }
	   else
	    { k=point-3072;
	      if(k < 0) k=0;
	      lseek(ftr,k,SEEK_SET);
	      if(point < buffer_point[0] && buffer_point[0] < buffer_point[1])
	       { buffer_point[1]=k;
		 buffer_size[1]=myread(ftr,buffer+5120,5120);
		 i=0;
	       }
	      else
	       { buffer_point[0]=k;
		 buffer_size[0]=myread(ftr,buffer,5120);
		 i=-1;
	       }
	    }
	 }
      }
     else
      { buffer_point[i]=point;
	buffer_ch[i]=0;
	buffer_size[i]=myread(ftr,buffer+i*5120,5120);
	i--;
      }
   }
  return(0);
}

int myread(int ftr,char *read_buffer,int read_size)
{ unsigned int k;
  long old_ftr;
  while(TRUE)
   { old_ftr=tell(ftr);
     k=read(ftr,read_buffer,read_size);
     if(error_flag)
      { while(TRUE)
	 { puts_message("ɮŪ~IR:Ū I: A:}  п... ",c.error_fc,c.error_bc,2);
	   if(*read_message == 'R' || *read_message == 'r'
	      || *read_message == 'I' || *read_message == 'i')
	    { lseek(ftr,old_ftr,SEEK_SET);
	      error_flag=0;
	      if(*read_message == 'R' || *read_message == 'r')
		break;
	      else
	       { lseek(ftr,0,SEEK_END);
		 lseek(ftr,-tell(ftr)+old_ftr+read_size,SEEK_END);
		 return(read_size);
	       }
	    }
	   else if(*read_message == 'A' || *read_message == 'a')
	    quit();
	 }
      }
     else return(k);
   }
}

int open_font_files(void)
{ char files[4][61];
  char *default_path[]={"ascfont.15","stdfont.15","spcfont.15","spcfsupp.15"};
  unsigned char font_path[323]=CHIN_FONT_PATH;
  for(ci=0;ci<4;ci++) files[ci][0]=NULL;
  for(ci=0,cj=0;ci<243;ci++)
   { if(font_path[ci] == '\n')
      { if(++cj > 4) break;
	if(cj!=0 && files[cj-1][0] == NULL)
	 { strcpy(temp,font_path+ci+1);
	   for(ck=0;ck<60;ck++)
	    if(temp[ck]==SPACE || temp[ck]=='\n' || temp[ck]==20 || temp[ck]==NULL) break;
	   temp[ck]=NULL;
	   strcpy(files[cj-1],temp);
	 }
      }
   }
  for(ci=0;ci<4;ci++)
   { if((font_handle[ci] = open(files[ci],O_RDONLY|O_BINARY)) == -1
	 && (font_handle[ci] = open(default_path[ci],O_RDONLY|O_BINARY)) == -1)
      { strcpy(error_message,"Chinese font open error ==> ");
	strcat(error_message,files[ci]);
	return(ERROR);
      }
   }
 return(TRUE);
}

/* PAGE DOWN FUNCTION */
int page_down(int ny)
{ long r_v;
  int i,j;
  r_v=read_lines(27);
  ny=0;
  if(nowx)
   { for(i=0;i<r_v;i++)
      line_cur(clist_lines[i],nowx-10);
     j=-80;
   }
  else j=0;
  for(i=0;i<r_v;i++,ny++)
   clist(j,ny<<4,clist_lines[i],640-j,c.main_fc,c.main_bc);
  if( r_v != 27 )
   { setfillstyle(SOLID_FILL,c.main_bc);
     bar(0,ny<<4,639,MAXY-48);
   }
  return(ny); /* Return nowy */
}

int parameter(char *para)
{ /* Change file_menu list */
  if(*para == '/' && (*(para+1) == 'f' || *(para+1) == 'F'))
   return(2);
  if( *para == '/' && ( *(para+1) == '?' || *(para+1) == 'h' ||
      *(para+1) == 'H'))
   return(1);  /* Clist Help */
  return(0);
}

/* void putpixel(int xx,int yy,int color)
{ union REGS reg;
  reg.h.ah=0x0c;
  reg.h.al=color;
  reg.x.cx=xx;
  reg.x.dx=yy;
  int86(0x10,&reg,&reg);
}  */

void puts_message(unsigned char *message,int fcolor,int bcolor,int fun)
{ int i,hitkey=0,now_point=0;
  char *buf;
  if(fun == 4)
   { if((buf=(char *)farmalloc(imagesize(0,0,460-128,15)))==NULL) return;
     getimage(64,464,460-64,464+15,buf);
   }
  if((i=strlen(message)) <= 49)
    clist(64,464,message,460-64,fcolor,bcolor);
  else
   { do{
      fun_key(hitkey);
      switch(hitkey)
       { case MOUSE_UP:
	 case UP1:
	 case UP2: if(now_point >= 49) now_point-=49;
		   break;
	 case MOUSE_DOWN:
	 case DOWN1:
	 case DOWN2:if(now_point < i-49) now_point +=49;
		    break;
	 case MOUSE_RIGHT:
	 case RIGHT1:
	 case RIGHT2:if(now_point < i) now_point++;
		     break;
	 case MOUSE_LEFT:
	 case LEFT1:
	 case LEFT2:if(now_point > 0) now_point--;
		    break;
	 case MOUSE_START:
	 case HOME1:
	 case HOME2:now_point=0;break;
	 case MOUSE_FILE_END:
	 case END1:
	 case END2:now_point=i-7;break;
       }
       clist(64,464,message+now_point,460-64,fcolor,bcolor);
      }while((hitkey = mygetch(0)) != ESC && !(mouse_event&0x2) && hitkey != MOUSE_ESC);
     delay(1000);
   }
  if(fun == 1 || fun == 4)
   { hit_anykey();
     if(fun == 4)
      { putimage(64,464,buf,COPY_PUT);
	farfree(buf);
      }
   }
  else if(fun == 2)
   *read_message = getch();
  else if(fun == 3)
   ggets(64+strlen(message)*8,464,read_message,(49-strlen(message))*8,fcolor,bcolor);
}

void quit(void)
{ if(graph_mode) closegraph();
  farfree(error_message);
  farfree(clist_buffer);
  for(ci=0;ci<5;ci++)
   farfree(font_ptr[ci]);
  for(ci=0;ci<4;ci++) close(font_handle[ci]);
  close(ftr);
  Mouse_End();
  if(chmode == 2) chinese_mode_chinese();
  if(error) puts(error_message);
  exit(0);
}

int read_lines(int r_lines)
{ int i=0,j=0,h=0,k;
  while(TRUE)
   { k=my_read(ftr,512);
     if(!k)
      { clist_lines[i][j]=NULL;
	return(i);
      }
     for(ci=0;ci<k;ci++,rb++)
      { if(*rb == '\n')
	 { if(!j)
	    clist_lines[i][j]=NULL;
	   else
	    { if(*(rb-1) == '\r')
	       clist_lines[i][--j]=NULL;
	      else
	       clist_lines[i][j]=NULL;
	    }
	   ++i,h=j=0;
	 }
	else if(*rb == 0x1a)
	 { clist_lines[i][j]=NULL;
	   ++i,h=j=0;
	 }
	else
	 { clist_lines[i][j]= *rb;
	   if(*rb == '\t')
	     h=((h>>3)+1)<<3,j++;
	   else
	     h++,j++;
	 }
	if( h > 256)
	 { clist_lines[i][j]=NULL;
	   ++i,j=0,h%=256;
	 }
	if( i==r_lines)
	 { lseek(ftr,ci-k+1,SEEK_CUR);
	   return(r_lines);
	 }
      }
   }
}


void screen_up(int line)
{ unsigned i,j;
  i = 1280*line;
  j = 34560-i;
  asm {
   push ds
   mov dx,3ceh
   mov ax,0105h
   out dx,ax
   mov ax,0a000h
   mov ds,ax
   mov es,ax
   mov si,i
   mov di,0h
   mov cx,j
   jcxz up_end
   cld
   rep movsb
  }
up_end:
  asm { mov dx,3ceh
	mov ax,0005h
	out dx,ax
	pop ds
      }
/*
color <<= 8;
  asm { mov dx,3ceh
	mov ax,0f01h
	out dx,ax
	mov ax,color
	out dx,ax
	mov cx,640
	mov ax,0a000h
	mov es,ax
	mov di,33280
	mov ax,0ffffh
      }
  up_again:
  asm { mov es:[di],ax
	add di,2
	loop up_again
	mov dx,3ceh
	mov ax,0001h
	out dx,ax
      } */
}

void screen_down(int line)
{ unsigned i;
  i = 34559-line*1280;
  asm {
   push ds
   mov dx,3ceh
   mov ax,0105h
   out dx,ax
   mov ax,0a000h
   mov ds,ax
   mov es,ax
   mov di,34559
   mov si,i
   mov cx,i
   inc cx
   jcxz do_end
   std
   rep movsb
  }
do_end:
  asm { mov dx,3ceh
	mov ax,0005h
	out dx,ax
	pop ds
      }
/*
color <<= 8;
  asm { mov dx,3ceh
	mov ax,0f01h
	out dx,ax
	mov ax,color
	out dx,ax
	mov cx,640
	mov ax,0a000h
	mov es,ax
	mov di,0h
	mov ax,0ffffh
      }
  do_again:
  asm { mov es:[di],ax
	add di,2
	loop do_again
	mov dx,3ceh
	mov ax,0001h
	out dx,ax
      } */
}

long search_line(long s_lines)
{ long i=0,start_at;
  int j,k,h=0;
  if(s_lines >= 0)
   while(TRUE)
    { if(s_lines < i+20)
       k=s_lines%20;
      else
       k=20;
      if((h=read_lines(k)) != k)
       return(h+i);
      else if( k != 20) return(s_lines);
       i+=20;
    }
  else
   while(TRUE)
    { start_at=tell(ftr);
      if(start_at < 512)
       { lseek(ftr,0,SEEK_SET);
	 k=my_read(ftr,(unsigned int)start_at);
       }
      else
       { lseek(ftr,-512,SEEK_CUR);
	 k=my_read(ftr,512);
       }
      for(rb=rb+k-1,j=k-1;j>=0;rb--,j--)
       { if(*rb == '\n' || *rb == 0x1a)
	  --i,h=0;
	 else if(*rb == '\t')
	  h=((h>>3)+1)<<3;
	 else h++;
	 if( h > 256) --i,h%=256;
	 if( i == s_lines-1)
	  { lseek(ftr,-k+j+1,SEEK_CUR);
	    return(s_lines);
	  }
       }
      if(k != 512)
       { lseek(ftr,0,SEEK_SET);
	 return(i);
       }
      lseek(ftr,-k,SEEK_CUR);
    }
}

void test_display(void)
{ char far *ptr;
  ptr = (char far *)0x410;
  if((*ptr >>4)%4 != 2)
   { puts("This program only surports VGA color mode !\n");
     exit(1);
   }
}

int test_path(char *lf,char *path,char *full_path)
{if((ci=strlen(lf)) > 80)
  { strcpy(error_message,"Input path too long !\n");
    return(ERROR);
  }
 if(!strcmp(lf,"*.*") || !strcmp(lf,".") || !strcmp(lf+1,":*.*") ||
    !strcmp(lf+1,":."))
  { ci=getdisk();
    if(!(!strcmp(lf,"*.*") || !strcmp(lf,".")))
     setdisk(toupper(lf[0])-65);
    getcwd(path,70);
    if(path[strlen(path)-1] != '\\')
     strcat(path,"\\");
    strcpy(full_path,path);
    strcat(full_path,"*.*");
    setdisk(ci);
    return(TRUE);
  }
 strcpy(path,lf);
 strcpy(full_path,lf);
 cj=0;
 if(full_path[1] == ':' && full_path[2] == NULL)
  { full_path[2]=path[2]= '\\';
    full_path[3]=path[3]= NULL;
    ci++;
  }
 if(full_path[ci-1] == '\\') strcat(full_path,"*.*");
 else if((ci == 1 && full_path[ci-1] == '.') || (full_path[ci-1] == '.' &&
	 (full_path[ci-2] == '\\' || full_path[ci-2] == ':')))
  strcpy(full_path+ci-1,"*.*");
 strcpy(path,full_path);
 for(cj=ci;cj>=0;cj--)
  if(path[cj] == '\\' || path[cj] == ':') break;
 path[cj+1]=NULL;
 return(TRUE);
}

int to_file_end(void)
{ long i,r_v;
  if(!end_point)
   for(i=0;;i++)
    { if(!(r_v=search_line(100)))
       { if(!i)
	  return(ERROR);
	 else
	  { end_lines=lines+=r_v;
	    end_point=tell(ftr);
	    return(TRUE);
	  }
       }
      else lines+=r_v;
    }
  else
   { if(!search_line(1))
      return(ERROR);
     else
      { lseek(ftr,end_point,SEEK_SET);
	lines=end_lines;
      }
   }
  return(TRUE);
}

void to_search_line(void)
{ long s_lines,ol,o_lines=lines;
  int hitkey;
  char keyflag=0;
  puts_message("ХLηƹӧܦCơI",c.message_fc,c.message_bc,0);
  do
   { ol=lines;
     if(keyflag)
      { hitkey=mygetch(hitkey);
	keyflag=0;
      }
     else hitkey=mygetch(0);
     fun_key(hitkey);
     switch(hitkey)
      { case CTRL_PAGE_UP : keyflag=1;
	case MOUSE_PAGE_UP :
	case MOUSE_PAGE_UP1:
	case PAGE_UP1:
	case PAGE_UP2: if(lines >= 100) lines-=100;
		       break;
	case CTRL_PAGE_DOWN : keyflag=1;
	case MOUSE_PAGE_DOWN :
	case MOUSE_PAGE_DOWN1:
	case PAGE_DOWN1 :
	case PAGE_DOWN2 : lines+=100;break;
	case CTRL_UP : keyflag=1;
	case MOUSE_UP :
	case MOUSE_UP1:
	case UP1:
	case UP2: if(lines > 0) lines--;
		  break;
	case CTRL_DOWN : keyflag=1;
	case MOUSE_DOWN :
	case MOUSE_DOWN1:
	case DOWN1:
	case DOWN2: lines++;
      }
     if(ol != lines) draw_lines(1);
   }while(hitkey != MOUSE_ESC && hitkey != ENTER && hitkey != ESC);
  s_lines=lines-o_lines;
  lines=o_lines;
  if(hitkey == ENTER)
   { puts_message("б ...",c.message_fc,c.message_bc,0);
     if((o_lines=search_line(s_lines)) == s_lines)
      puts_message("jM\\I",c.message_fc,c.message_bc,0);
     else
      puts_message("jMѡAƿ~I",c.message_fc,c.message_bc,0);
     nowy=page_down(0);
     if(!nowy)
      { lines +=search_line(-27);
	nowy=page_down(0);
      }
     lines+=(o_lines+nowy);
   }
  find_file_sit();
  draw_file_sit();
}

int true_strlen(unsigned char *str)
{ char *dp;
  for(dp=str,cj=0;*dp;dp++)
   if(*dp == '\t') cj=((cj>>3)+1)<<3;
   else cj++;
  return(cj);
}

/** Mouse handler */
int detect_mouse_key()
{ if(mouse_button&0x6)
   { if(mouse_y < MAXY-47 && mouse_y >= MAXY-147)
       { if(mouse_button&0x4) return(61);		      /* Page UP */
	 return(41);					      /* Scrool UP */
       }
     if(mouse_y <= 100)
       { if(mouse_button&0x4) return(51);		      /* Page DOWN */
	  return(31);					      /* Scrool DOWN */
       }
     if(mouse_x <= 150 && mouse_y < MAXY-47) return(21);      /* Scrool LEFT */
     if(mouse_x >= 490 && mouse_y < MAXY-47) return(11);      /* Scrool RIGHT */
   }
  if((mouse_x > 460 && mouse_x < 460 + 30) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY-23))
    { if(mouse_button & 0x1) return(10);
    }
  if((mouse_x > 460 && mouse_x < 460 + 30) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(20);
    }
  if((mouse_x > 460+30 && mouse_x < 460 + 60) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY -23))
    { if(mouse_button & 0x1)
       return(30);
    }
  if((mouse_x > 460+30 && mouse_x < 460 + 60) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(40);
    }
  if((mouse_x > 460+60 && mouse_x < 460 + 90) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY - 23))
    { if(mouse_button & 0x1)
       return(50);
    }
  if((mouse_x > 460+60 && mouse_x < 460 + 90) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(60);
    }
   if((mouse_x > 460+90 && mouse_x < 460 + 120) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY - 23))
    { if(mouse_button & 0x1)
       return(70);
    }
   if((mouse_x > 460+90 && mouse_x < 460 + 120) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(80);
    }
   if((mouse_x > 460+120 && mouse_x < 460 + 150) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY - 23))
    { if(mouse_button & 0x1)
       return(90);
    }
   if((mouse_x > 460+120 && mouse_x < 460 + 150) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(100);
    }
   if((mouse_x > 460+150 && mouse_x < 460 + 180) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY - 23))
    { if(mouse_button & 0x1)
       return(110);
    }
   if((mouse_x > 460+150 && mouse_x < 460 + 180) &&
     (mouse_y > MAXY-23 && mouse_y <= MAXY))
    { if(mouse_button & 0x1)
       return(120);
    }
   if((mouse_x >= 64 && mouse_x <= 64+8*6) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY-31) && (mouse_button&0x1))
    { wait_mouse_release(0x3);
      return(130);
    }
   if((mouse_x >= 64+8*32 && mouse_x <= 64+8*40) &&
     (mouse_y >= MAXY-47 && mouse_y < MAXY-31) && (mouse_button&0x1))
    { wait_mouse_release(0x3);
      return(150);
    }
   if((mouse_x > 64 && mouse_x < 64+80) &&
    (mouse_y > MAXY-16 && mouse_y <= MAXY) && (mouse_button&0x1))
    { wait_mouse_release(0x3);
      return(180);
    }
   if(mouse_x < 64 && (mouse_y > MAXY-47 && mouse_y < MAXY)
      && (mouse_button&0x1))
    { wait_mouse_release(0x3);
      return(300);
    }
   return(1);
}

int run_mouse(void)
{ int i;
  if(mouse_avail)
   { Mouse_Show();
     while(!kbhit())
      { if(mouse_event)
	 { i=detect_mouse_key();
	   Mouse_Hide();
	   if(!mouse_button) mouse_event=0;
	   return(i);
	 }
      }
     Mouse_Hide();
     return(0);
   }
  else
   { Mouse_End();
     return(0);
   }
}

extern void far MouseHand(void);
void far Mouse_Event_Handler(int EventFlags,int ButtonStatus,int Mouse_x,int Mouse_y);

void far Mouse_Event_Handler(int EventFlags,int ButtonStatus,int Mouse_x,int Mouse_y)
{  if(!(EventFlags&0x1)) mouse_event = EventFlags;
   mouse_button = ButtonStatus;
   mouse_x=(int)Mouse_x ;
   mouse_y =(int)Mouse_y ;
}

int  Mouse_Init(void)
{  if(!(button_num=Mouse_Reset())) return(mouse_avail=FALSE);
   Mouse_X_Range(0,MAXX);     /* set range of mouse's movement */
   Mouse_Y_Range(0,MAXY);
   Mouse_Graphics_Shape(0,0,(unsigned int far *) mouse_stdptr=normal_mask);
   Mouse_Set_Event_Handler(EV_MOUSE_ALL,MouseHand);
   return(mouse_avail=TRUE);
}

int mouse_double_click(int bx,int by,int key)
{ clock_t times;
  ci=mouse_x,cj=mouse_y,ck=0;
  times=clock();
  Mouse_Show();
  while((mouse_x-ci > 0 ? mouse_x - ci : ci-mouse_x) <= bx &&
	(mouse_y-cj > 0 ? mouse_y - cj : cj-mouse_y) <= by &&
	 clock()-times <= 19 && ck != 3) /* One Second	*/
   { if(!(mouse_button & key) && ck == 0) ck=1;
     if(ck)
      { if(mouse_button & key)
	  ck=2;
	if(ck == 2 && !(mouse_button & key))
	  ck=3;
      }
   }
  Mouse_Hide();
  if(ck == 3) return(TRUE);
  return(FALSE);
}

void Mouse_End(void)
{  Mouse_Hide();
   Mouse_Reset();
}

void wait_mouse_release(unsigned key)
{ while(TRUE)
   { if(key == (key&(~mouse_button))) return;
     mouse_button = Get_Mouse_Button_Status();	  /* Without this function */
   }						  /* mouse_button sometime */
}						  /* can't get expectative */
						  /* when you type clist *.*/
						  /* It seen a bug	   */



